// jshint esversion: 6	
	import * as THREE from 'three';


	// corrector fermi
	export function correctorfermi(length=400) {
		const CorrectorContiner = new THREE.Object3D();
		const CorrectorMaster = new THREE.Object3D();
		
		// coil settings
		const loader = new THREE.TextureLoader();
		const texture = loader.load('./components/coil_texture_fermi.png');
		const textureTop = texture.clone();
		const textureSide = texture.clone();
		texture.wrapS = texture.wrapT = THREE.RepeatWrapping;
		texture.repeat.set(2, 20);
		textureTop.center.set(0.5, 0.5);
		textureTop.rotation = THREE.MathUtils.degToRad(90);
		textureSide.offset.set(0, 0.8);
		const dmaterial = new THREE.MeshLambertMaterial({map: texture});
		const face = new THREE.MeshBasicMaterial({map: texture});
		const faceTop = new THREE.MeshBasicMaterial({map: textureTop});
		const faceSide = new THREE.MeshBasicMaterial({map: textureSide});
		const materials = [face,face,faceTop,faceSide,faceSide,faceSide];
		const d1geometry = new THREE.CylinderGeometry(500, 500, length, 4 /*radialSegments*/, 2 /*heightSegments*/, true /*openEnded*/,0 /*thetaStart*/, Math.PI * 2 /*thetaLength*/);
		const d1mesh = new THREE.Mesh(d1geometry, materials);
		d1mesh.position.set(0, 0, 0);
		d1mesh.rotateX(Math.PI * 1.25);
		d1mesh.rotateY(Math.PI * 1);
		d1mesh.rotateZ(Math.PI * 1.5);	
		CorrectorMaster.add(d1mesh);	
		
	

		//spessore esterno plastica bianca
		const redmaterialp = new THREE.MeshLambertMaterial({color: 0xeD2D2D2, side:THREE.DoubleSide});
		const geometry_1p = new THREE.CylinderGeometry(501 /*radiusTop*/, 501 /*radiusBottom*/, 90 /*height*/, 4 /*radialSegments*/, 2 /*heightSegments*/, true /*openEnded*/,0 /*thetaStart*/, Math.PI * 2 /*thetaLength*/);
		const dmesh_1p = new THREE.Mesh(geometry_1p, redmaterialp);
		dmesh_1p.position.set(0, 0, 0);
		dmesh_1p.rotateX(Math.PI * 1.25);
		dmesh_1p.rotateY(Math.PI * 1);
		dmesh_1p.rotateZ(Math.PI * 1.5);	
		CorrectorMaster.add(dmesh_1p); 
		
		//spessore alto centro
		const redmaterial_5 = new THREE.MeshLambertMaterial({color: 0xeD2D2D2});
		const geometry_1_5 = new THREE.BoxGeometry(length, 150, 700);
		const dmesh_1_5 = new THREE.Mesh(geometry_1_5, redmaterial_5);
		dmesh_1_5.position.set(0, 277, 0);
		CorrectorMaster.add(dmesh_1_5);
		
		//spessore basso
		const dmesh_2 = new THREE.Mesh(geometry_1_5, redmaterial_5);
		dmesh_2.position.set(0, -277, 0);
		CorrectorMaster.add(dmesh_2);
		
		//spessore destro
		const geometry_3 = new THREE.BoxGeometry(length, 600, 150);
		const dmesh_3 = new THREE.Mesh(geometry_3, redmaterial_5);
		dmesh_3.position.set(0, 0, -275);
		CorrectorMaster.add(dmesh_3);	
		
		//spessore sinistro
		const dmesh_4 = new THREE.Mesh(geometry_3, redmaterial_5);
		dmesh_4.position.set(0, 0, 275);
		CorrectorMaster.add(dmesh_4);	
		
		//cubo al centro
		const loader_2 = new THREE.TextureLoader();
		const texture_2 = loader.load('./components/coil_texture_fermi.png');
		texture_2.wrapS = texture_2.wrapT = THREE.RepeatWrapping;
		texture_2.repeat.set(20, 20);
		const textureTop_2 = texture.clone();
		const textureSide_2 = texture.clone();
		const dmaterial_2 = new THREE.MeshLambertMaterial({map: texture_2});
		const geometry_2 = new THREE.BoxGeometry(390, 390, 390);
		const dmesh_5 = new THREE.Mesh(geometry_2, dmaterial_2);
		dmesh_5.position.set(0, 0, 0);		
		CorrectorMaster.add(dmesh_5);
		
		//spessore interno plastica bianca
		const redmaterial_6 = new THREE.MeshLambertMaterial({color: 0xeD2D2D2, side:THREE.DoubleSide});
		const geometry_6 = new THREE.CylinderGeometry(280 /*radiusTop*/, 280 /*radiusBottom*/, 90 /*height*/, 4 /*radialSegments*/, 2 /*heightSegments*/, true /*openEnded*/,0 /*thetaStart*/, Math.PI * 2 /*thetaLength*/);
		const dmesh_6 = new THREE.Mesh(geometry_6, redmaterial_6);
		dmesh_6.position.set(0, 0, 0);
		dmesh_6.rotateX(Math.PI * 1);
		dmesh_6.rotateY(Math.PI * 1.25);
		dmesh_6.rotateZ(Math.PI * 1);	
		CorrectorMaster.add(dmesh_6); 
				

		
		CorrectorMaster.position.set(0, 0, 0);
		CorrectorContiner.add(CorrectorMaster);
		CorrectorContiner.rotateY(Math.PI * 1);
		CorrectorContiner.scale.setX(0.25);
		CorrectorContiner.scale.setY(0.125);
		CorrectorContiner.scale.setZ(0.25);
		
		return CorrectorContiner;
	}
