// jshint esversion: 6	
	import * as THREE from 'three';

	// quadrupole booster
	export function quadrupolebooster(length=200) {
		const QuadrupolContiner = new THREE.Object3D();
		const QuadrupoleMaster = new THREE.Object3D();
		
		const dmaterial = new THREE.MeshLambertMaterial({color: 0xe05040, side: THREE.DoubleSide});
		const d1geometry = new THREE.CylinderGeometry(500, 500, length, 4 /*radialSegments*/, 2 /*heightSegments*/, true /*openEnded*/,0 /*thetaStart*/, Math.PI * 2 /*thetaLength*/);
		const d1mesh = new THREE.Mesh(d1geometry, dmaterial);
		d1mesh.position.set(0, 0, 0);
		d1mesh.rotateX(Math.PI * 1.25);
		d1mesh.rotateY(Math.PI * 1);
		d1mesh.rotateZ(Math.PI * 1.5);	
		QuadrupoleMaster.add(d1mesh);	
		
		// coil settings
		const coilmaterial = new THREE.MeshLambertMaterial({color: 0xcd7f32, side: THREE.DoubleSide});
		const textureLoader = new THREE.TextureLoader();
		const texture = textureLoader.load('./components/coil_texture.png');
		texture.wrapS = texture.wrapT = THREE.RepeatWrapping;
		texture.repeat.set(5, 5);
		const coiltexture = new THREE.MeshBasicMaterial({ map: texture });
		const coilmaterials = [coiltexture, coilmaterial, coilmaterial];
		const coilgeometry = new THREE.CylinderGeometry(110 /*radiusTop*/, 110 /*radiusBottom*/, 120 /*height*/, 25 /*radialSegments*/, 4 /*heightSegments*/, false /*openEnded*/,Math.PI * 1.5 /*thetaStart*/, Math.PI * 2 /*thetaLength*/);
		
		//spessore alto
		const redmaterial = new THREE.MeshLambertMaterial({color: 0xe05040});
		const geometry_1 = new THREE.BoxGeometry(200, 100, 705);
		const dmesh_1 = new THREE.Mesh(geometry_1, redmaterial);
		dmesh_1.position.set(0, 300, 0);
		QuadrupoleMaster.add(dmesh_1);
		
		//spessore basso
		const dmesh_2 = new THREE.Mesh(geometry_1, redmaterial);
		dmesh_2.position.set(0, -300, 0);
		QuadrupoleMaster.add(dmesh_2);
		
		//spessore destro
		const geometry_3 = new THREE.BoxGeometry(200, 500, 100);
		const dmesh_3 = new THREE.Mesh(geometry_3, redmaterial);
		dmesh_3.position.set(0, 0, -300);
		QuadrupoleMaster.add(dmesh_3);	
		
		//spessore sinistro
		const dmesh_4 = new THREE.Mesh(geometry_3, redmaterial);
		dmesh_4.position.set(0, 0, 300);
		QuadrupoleMaster.add(dmesh_4);			

		const geometry_5 = new THREE.BoxGeometry(200, 115, 280);
		const dmesh_5 = new THREE.Mesh(geometry_5, redmaterial);
		dmesh_5.rotateX(Math.PI * 0.25);
		dmesh_5.position.set(0, 210, 210);
		QuadrupoleMaster.add(dmesh_5);			
		const dmesh_6 = new THREE.Mesh(geometry_5, redmaterial);
		dmesh_6.rotateX(Math.PI * 0.75);
		dmesh_6.position.set(0, 210, -210);
		QuadrupoleMaster.add(dmesh_6);			
		const dmesh_7 = new THREE.Mesh(geometry_5, redmaterial);
		dmesh_7.rotateX(Math.PI * 0.75);
		dmesh_7.position.set(0, -210, 210);
		QuadrupoleMaster.add(dmesh_7);			
		const dmesh_8 = new THREE.Mesh(geometry_5, redmaterial);
		dmesh_8.rotateX(Math.PI * 0.25);
		dmesh_8.position.set(0, -210, -210);
		QuadrupoleMaster.add(dmesh_8);			
		
		// coil basso destra 
		const d2mesh = new THREE.Mesh(coilgeometry, coilmaterials);
		d2mesh.position.set(0, -130, 120);
		d2mesh.rotateX(Math.PI * 1.25);
		d2mesh.rotateY(Math.PI * 1.50);
		d2mesh.rotateZ(Math.PI * 1.50);
		QuadrupoleMaster.add(d2mesh);

		// coil basso sinistra 
		const d3mesh = new THREE.Mesh(coilgeometry, coilmaterials);
		d3mesh.position.set(0, -130, -120);
		d3mesh.rotateX(Math.PI * 1.75);
		d3mesh.rotateY(Math.PI * 1.50);
		d3mesh.rotateZ(Math.PI * 1.50);
		QuadrupoleMaster.add(d3mesh);
		
		// coil alto destra 
		const d4mesh = new THREE.Mesh(coilgeometry, coilmaterials);
		d4mesh.position.set(0, 130, 120);
		d4mesh.rotateX(Math.PI * 0.75);
		d4mesh.rotateY(Math.PI * 1.50);
		d4mesh.rotateZ(Math.PI * 1.50);
		QuadrupoleMaster.add(d4mesh);

		// coil alto destra 
		const d5mesh = new THREE.Mesh(coilgeometry, coilmaterials);
		d5mesh.position.set(0, 130, -120);
		d5mesh.rotateX(Math.PI * 1.25);
		d5mesh.rotateY(Math.PI * 1.50);
		d5mesh.rotateZ(Math.PI * 1.50);
		QuadrupoleMaster.add(d5mesh);
		
		QuadrupoleMaster.position.set(0, 0, 0);
		QuadrupolContiner.add(QuadrupoleMaster);
		QuadrupolContiner.rotateY(Math.PI * -0.5);
				
		
		return QuadrupolContiner;
	}
